"""Componets for the administration graphical user interface."""
import clr
clr.AddReference("System.Windows.Forms")
clr.AddReference("System.Drawing")
import System
import System.Windows.Forms
import System.Drawing
import RemoteAdmin
import RemoteServices 
import GuiControls
import FormExceptions
import Enums

        
class GetServerAddressDialog(System.Windows.Forms.Form):
    """Ask the user for the hostname or IP address of a server."""
    def __init__(self):
        # basic window settings
        System.Windows.Forms.Form.__init__(self)
        self.SuspendLayout()
        self.Size = System.Drawing.Size(400, 100)
        self.Text = "Server hostname or IP address..."
        self.ControlBox = False
        # Make a 2x2 layout panel so we can put the ok and cancel buttons on
        # the right, and the text input box over on the left
        panel = System.Windows.Forms.TableLayoutPanel()
        panel.SuspendLayout()
        self.Controls.Add(panel)
        panel.ColumnCount = 2
        panel.RowCount = 2
        panel.ColumnStyles.Add(System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100))
        panel.ColumnStyles.Add(System.Windows.Forms.ColumnStyle())
        panel.RowStyles.Add(System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 50))
        panel.RowStyles.Add(System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 50))
        panel.Dock = System.Windows.Forms.DockStyle.Fill
        # create the ok and cancel buttons
        ok = GuiControls.OkDialogButton()
        ok.Anchor = System.Windows.Forms.AnchorStyles.None
        ok.Dock = System.Windows.Forms.DockStyle.None
        panel.Controls.Add(ok, 1, 0)
        self.AcceptButton = ok
        cancel = GuiControls.CancelDialogButton()
        cancel.Anchor = System.Windows.Forms.AnchorStyles.None
        cancel.Dock = System.Windows.Forms.DockStyle.None
        panel.Controls.Add(cancel, 1 ,1)
        self.CancelButton = cancel
        # text entry box for server address
        self.serverAddressText = System.Windows.Forms.TextBox()
        panel.Controls.Add(self.serverAddressText,0,0)
        panel.SetRowSpan(self.serverAddressText, 2)
        self.serverAddressText.Dock = System.Windows.Forms.DockStyle.None
        self.serverAddressText.Anchor = (System.Windows.Forms.AnchorStyles.Left | \
                        System.Windows.Forms.AnchorStyles.Right)
        panel.ResumeLayout()
        self.ResumeLayout()
    def OnShown(self, *args):
        """Set the focus to the text entry box whenever the dialog is shown."""
        self.serverAddressText.Focus()
        System.Windows.Forms.Form.OnShown(self, *args)
    def GetServerAddress(self):
        """Get what the user entered for the server address."""
        return self.serverAddressText.Text
